#!/usr/bin/perl
use CGI::Carp qw(fatalsToBrowser);

# 062404
#####################################################################
#                                                                   #
#    Copyright  1999-2004 CGISCRIPT.NET - All Rights Reserved     #
#                                                                   #
#####################################################################
#                                                                   #
#          THIS COPYRIGHT INFORMATION MUST REMAIN INTACT            #
#                AND MAY NOT BE MODIFIED IN ANY WAY                 #
#                                                                   #
#####################################################################
#
# When you downloaded this script you agreed to accept the terms
# of this Agreement. This Agreement is a legal contract, which
# specifies the terms of the license and warranty limitation between
# you and CGISCRIPT.NET. You should carefully read the following
# terms and conditions before installing or using this software.
# Unless you have a different license agreement obtained from
# CGISCRIPT.NET, installation or use of this software indicates
# your acceptance of the license and warranty limitation terms
# contained in this Agreement. If you do not agree to the terms of this
# Agreement, promptly delete and destroy all copies of the Software.
#
# Versions of the Software
# Only one copy of the registered version of CGISCRIPT.NET
# may used on one web site.
#
# License to Redistribute
# Distributing the software and/or documentation with other products
# (commercial or otherwise) or by other than electronic means without
# CGISCRIPT.NET's prior written permission is forbidden.
# All rights to the CGISCRIPT.NET software and documentation not expressly
# granted under this Agreement are reserved to CGISCRIPT.NET.
#
# Disclaimer of Warranty
# THIS SOFTWARE AND ACCOMPANYING DOCUMENTATION ARE PROVIDED "AS IS" AND
# WITHOUT WARRANTIES AS TO PERFORMANCE OF MERCHANTABILITY OR ANY OTHER
# WARRANTIES WHETHER EXPRESSED OR IMPLIED.   BECAUSE OF THE VARIOUS HARDWARE
# AND SOFTWARE ENVIRONMENTS INTO WHICH CGISCRIPT.NET MAY BE USED, NO WARRANTY
# OF FITNESS FOR A PARTICULAR PURPOSE IS OFFERED.  THE USER MUST ASSUME THE
# ENTIRE RISK OF USING THIS PROGRAM.  ANY LIABILITY OF CGISCRIPT.NET WILL BE
# LIMITED EXCLUSIVELY TO PRODUCT REPLACEMENT OR REFUND OF PURCHASE PRICE.
# IN NO CASE SHALL CGISCRIPT.NET BE LIABLE FOR ANY INCIDENTAL, SPECIAL OR
# CONSEQUENTIAL DAMAGES OR LOSS, INCLUDING, WITHOUT LIMITATION, LOST PROFITS
# OR THE INABILITY TO USE EQUIPMENT OR ACCESS DATA, WHETHER SUCH DAMAGES ARE
# BASED UPON A BREACH OF EXPRESS OR IMPLIED WARRANTIES, BREACH OF CONTRACT,
# NEGLIGENCE, STRICT TORT, OR ANY OTHER LEGAL THEORY. THIS IS TRUE EVEN IF
# CGISCRIPT.NET IS ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. IN NO CASE WILL
# CGISCRIPT.NET' LIABILITY EXCEED THE AMOUNT OF THE LICENSE FEE ACTUALLY PAID
# BY LICENSEE TO CGISCRIPT.NET.
#
# Credits:
# Andy Angrick - Programmer - angrick@cgiscript.net
# Mike Barone - Design - mbarone@cgiscript.net
#
# For information about this script or other scripts see
# http://www.cgiscript.net
#
# Thank you for trying out our script.
# If you have any suggestions or ideas for a new innovative script
# please direct them to suggest@cgiscript.net.  Thanks.

#Config Variables

$basepath='./';

require("$basepath/libs.cgi");
require("$basepath/setup.cgi");
$in{'cgiurl'} = $cgiurl.'/usermanage.cgi';
$in{'fsurl'} = 'CSFileshare.cgi';

$userfile = "$basepath/users.cgi";

$debug=0;
$flock=1;
$in{'entriesperpage'} = 20;


#end config

$| = 1;				# Flush Output Right Away
&main;

sub main{
&getdata;
($ENV{'PATH_INFO'} eq '/export.csv')&&(&DoExport);
print "Content-type: text/html\n\n";
($in{'command'} eq "login")&&(&Login);
&GetLogin;
($in{'command'} eq "")&&(&Manage);
($in{'command'} eq 'manage')&&(&Manage);
($in{'command'} eq 'showadd')&&(&ShowAdd);
($in{'command'} eq 'add')&&(&Add);
($in{'command'} eq 'showedit')&&(&ShowEdit);
($in{'command'} eq 'delete')&&(&Delete);
($in{'command'} eq 'savechanges')&&(&SaveChanges);
($in{'command'} eq 'showadddrives')&&(&ShowAddDrives);
}

sub ShowAddDrives{
open(DB,"<$userfile")||print "$!:$userfile<br>";
while(<DB>){
chomp;
@fields = split(":",$_);
if($fields[0] eq $in{'id'}){
  $in{'musername'} = $fields[0];
  $in{'mpassword'} = $fields[1];
  $in{'name'} = $fields[2];
  $in{'level'} = $fields[3];
  $in{'projects'} = $fields[4];
  @mp = split(",",$in{'projects'});
  $in{'projects'} =~ s/\,/\n/g;
  last;
  }
}
close DB;

print "<font face=\"verdana\" size=2><b>Drive access</b><br>";
foreach my $i (@mp){
  print "$i<br>";
  }
  
print <<"EOF";
<center>
<form><input class=text type=button value="Close" onClick="window.close()"></form>
</center>
EOF

exit;
}

sub DoExport{
$good=0;
&GetCookies;
$in{'UserName'} = $cookie{'UserName'};
$in{'PassWord'} = $cookie{'PassWord'};
if(!$in{'UserName'}){
print "Content-type: text/html\n\n";
&PageOut("$basepath/t_login.htm");
exit;
}
else{
  if(($in{'UserName'} eq $username)&&($in{'PassWord'} eq $password)){
    $good=1;
    }
 if(!$good){
 print "Content-type: text/html\n\n";
 &PError("Error. Invalid username or password");
 }
}

print "Content-type: application/msexcel\n\n";
print qq|"Name","Level","Username","Password","Projects"\n|;

open(DB,"<$userfile");
while(<DB>){
chomp;
@fields = split(":",$_);
print qq|"$fields[2]","$fields[3]","$fields[0]","$fields[1]","$fields[5]"\n|;
}
close DB;
exit;
}

sub Delete{
open(DB,"+<$userfile");
while(<DB>){
  @f = split(":",$_);
  ($f[0] ne $in{'id'})&&(push(@l,$_));
  }
seek(DB,0,0);
if(@l){
foreach $i (@l){
  print DB $i;
  }
}
truncate(DB,tell(DB));
close DB;
print <<"EOF";
<script language=javascript>
var rndURL = (1000*Math.random());
alert("User removed");
window.location = "$in{'cgiurl'}?command=manage&query=$in{'query'}&folder="+escape("$in{'folder'}")+"&rnd="+rndURL;
</script>
EOF
exit;
}

sub SaveChanges{
&GetOutVars;

open(DB,"+<$userfile");
while(<DB>){
  @f = split(":",$_);
  ($f[0] ne $in{'id'})?(push(@l,$_)):(push(@l,"$newentry\n"));
  }
seek(DB,0,0);
if(@l){
foreach $i (@l){
  print DB $i;
  }
}
truncate(DB,tell(DB));
close DB;

&ReOrder;

print <<"EOF";
<script language=javascript>
var rndURL = (1000*Math.random());
alert("User saved.");
window.opener.location = "$in{'cgiurl'}?command=manage&query=$in{'query'}&folder="+escape("$in{'folder'}")+"&rnd="+rndURL;
window.close();
</script>
EOF
exit;
}

sub ShowEdit{

open(DB,"<$userfile")||print "$!:$userfile<br>";
while(<DB>){
chomp;
@fields = split(":",$_);
if($fields[0] eq $in{'id'}){
  $in{'musername'} = $fields[0];
  $in{'mpassword'} = $fields[1];
  $in{'name'} = $fields[2];
  $in{'level'} = $fields[3];
  $in{'projects'} = $fields[4];  
  $in{'permissions-u'} = $fields[5];
  $in{'permissions-d'} = $fields[6];
  $in{'permissions-c'} = $fields[7];
  
  @mp = split(",",$in{'projects'});
  
  @mpu = split(",",$in{'permissions-u'});
  @mpd = split(",",$in{'permissions-d'});
  @mpc = split(",",$in{'permissions-c'});
  
  $in{'projects'} =~ s/\,/\n/g;
  last;
  }
}
close DB;

foreach $i (@mp){
  $sel{$i} = 'checked';
  }

foreach $i (@mpu){
  $sel{$i} = 'checked';
  }
  
foreach $i (@mpd){
  $sel{$i} = 'checked';
  }
  
foreach $i (@mpc){
  $sel{$i} = 'checked';
  }

$in{'command'} = 'savechanges';
$in{'readonly'} = 'readonly';
&GetProjects;
&PageOut("$basepath/t_admin_add.htm");
exit;
}

sub Add{
&GetOutVars;

open(DB,"<$userfile")||print "$!:$userfile";
while(<DB>){
@f = split(":",$_);
($f[0] eq $in{'musername'})&&(&PError("Error. User already exists"));
}
close DB;

open(DB,">>$userfile")||print "$!:$userfile";
print DB "$newentry\n";
close DB;

&ReOrder;

print <<"EOF";
<script language=javascript>
var rndURL = (1000*Math.random());
alert("User added");
window.opener.location = "$in{'cgiurl'}?command=manage&query=$in{'query'}&folder="+escape("$in{'folder'}")+"&rnd="+rndURL;
window.close();
</script>
EOF
exit;
}

sub ShowAdd{

&GetProjects;
$in{'command'} = 'add';

&PageOut("$basepath/t_admin_add.htm");
exit;
}

sub GetLogin{
&GetCookies;
$in{'UserName'} = $cookie{'UserName'};
$in{'PassWord'} = $cookie{'PassWord'};

if(!$in{'UserName'}){
  &PageOut("$basepath/t_login.htm");
  exit;
  }
else{
  ##open the user database
  open(USERS,"<$userfile")||die print "$!:$userfile<br>";;
  while(<USERS>){
    chomp;
    ($username,$password,$name,$level,$drives) = split(":",$_);
    last if($in{'UserName'} eq $username);
    }
  close USERS;
}
(($in{'UserName'} ne $username)||(($in{'PassWord'} ne $password)))&&(&PError("Error. Invalid username or password"));
($level ne 'admin')&&(&PError("Error. You don't have access user management"));
}


sub Login{
&PageOut("$basepath/t_login.htm");
exit;
}

sub Manage{
#my $count;
(!$in{'page'})&&($in{'page'} = 1);
$start = ($in{'page'}*$in{'entriesperpage'})-$in{'entriesperpage'};
$end = $start + $in{'entriesperpage'};

open(DB,"<$userfile");
while(<DB>){
  chomp;
  push(@users,$_);
  }
close DB;

$in{'dcount'} = $#users;


if($in{'terms'}){
foreach $i (@users){
  ($i =~ /$in{'terms'}/i)&&(push(@tmp,$i));
  }
undef @users;
push(@users,@tmp);
undef @tmp;
$in{'dcount'} = $#users;
}
else{
  if($in{'query'} ne 'ALL'){
    foreach $i (@users){
      @f = split(":",$i);
      ($f[2] =~ /^$in{'query'}/i)&&(push(@tmp,$i));
      }
    undef @users;
    push(@users,@tmp);
    undef @tmp;
    $in{'dcount'} = $#users;
    }
}

$in{'dcount'}++;

foreach $i (@users){
$count++;
if(($count > $start) & ($count <= $end)){
@f = split(":",$i);
@drv = split(",",$f[4]);
$drives='';
$dc=0;
foreach my $u (@drv){
$dc++;
$drives .= "$u<br>";
if($dc > 6){
  $drives .= "<a href=\"javascript:ShowAddDrives('$f[0]');\">more..</a>";
  last;
  }
}

$in{'line'} .= qq|
    <tr bgcolor=#efefef>
      <td valign=top>
      <table border="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111">
        <tr>
          <td align="center"><input class=button type="button" value="Modify" onClick="ShowEdit('$f[0]');"></td>
          <td align="center"><input class=button type="button" value="Delete" onClick="Delete('$f[0]');"></td>
        </tr>
      </table>
      </td>
      <td nowrap valign=top><font size="2" face="Tahoma" align=left valign=top>$f[0]</font></td>
      <td nowrap valign=top><font size="2" face="Tahoma" align=left valign=top>$f[2]</font></td>
      <td nowrap valign=top><font face="Tahoma" size="2" align=left valign=top>$f[3]&nbsp;</td>
      <td nowrap valign=top><font face="Tahoma" size="2" align=left valign=top>$drives&nbsp;</td>
     </tr>
|;

}
}
$in{'count'} = $count;

&GetNlinks;
&GetNlinks2;
($in{'dcount'})&&($in{'dcount'} = "$in{'dcount'} records in search result");
(!$in{'line'})&&($in{'line'} = '<tr><td colspan=4><font face=verdana size=2>No users match that search criteria</td></tr>');
&PageOut("$basepath/t_manage_members.htm");
exit;
}

sub GetNlinks2{
for $i (A..Z){
  $in{'link2'} .= qq|<a href="$in{'cgiurl'}?command=manage&query=$i&folder=$in{'folder'}">[$i]</a> |;
  }
  $in{'link2'} .= qq|<a href="$in{'cgiurl'}?command=manage&query=ALL&folder=$in{'folder'}">[View All]</a> |;
}


sub GetNlinks{
((!$in{'page'})||($in{'lpage'} < 0))&&($in{'lpage'} = 1);
$nstart = ($in{'lpage'}+10)-10;
$nend = $nstart + 10;
$sstring = "command=$in{'command'}&query=$in{'query'}&folder=$in{'folder'}";
$sstring =~ s/([^\w&=])/'%'.sprintf("%.2x",ord($1))/ge;

$npages = int($count/$in{'entriesperpage'});
(($count/$in{'entriesperpage'}) > $npages)&&($npages++);
#print "S: $nstart E: $nend Total # pages: $npages $count/$in{'entriesperpage'} <br>";

for $i (1..$npages){
  if(($i > $nstart) & ($i <= $nend)){
    ($i eq $in{'page'})?($link .= " <b>$i</b> "):($link .= " <a href=\"$in{'cgiurl'}?page=$i&lpage=$in{'lpage'}&$sstring\">$i</a> ");
    }
  }
$nend;
$pend = $nend - 20;
($npages > $nend)&&($link .= " <a href=\"$in{'cgiurl'}?page=$nend&lpage=$nend&$sstring\">[Next]</a> ");
($nend > 11)&&($link = " <a href=\"$in{'cgiurl'}?page=$pend&lpage=$pend&$sstring\">[Prev]</a> " . $link);
(!$link)&&($link='0');
$link .= "</font>";
$link = "<FONT face=tahoma size=2>Result Pages:" . $link;
$in{'link'} = $link;
}

sub GetOutVars{
(!$in{'name'})&&(&PError("Error. Please enter a name"));
(!$in{'level'})&&(&PError("Error. Please select a level"));
(!$in{'musername'})&&(&PError("Error. Please enter a username"));
(!$in{'mpassword'})&&(&PError("Error. Please enter a password"));
@allp = split(/\\0/,$in{'mp'});

@allpu = split(/\\0/,$in{'mp-u'});
@allpd = split(/\\0/,$in{'mp-d'});
@allpc = split(/\\0/,$in{'mp-c'});

$in{'projects'} = join(",",@allp);

$in{'permissions-u'} = join(",",@allpu);
$in{'permissions-d'} = join(",",@allpd);
$in{'permissions-c'} = join(",",@allpc);

$newentry = "$in{'musername'}:$in{'mpassword'}:$in{'name'}:$in{'level'}:$in{'projects'}:$in{'permissions-u'}:$in{'permissions-d'}:$in{'permissions-c'}";
}


sub ReOrder{
open(DB,"+<$userfile");
flock(DB,2);
while(<DB>){
  @f = split(":",$_);
  $sort{"$f[2]-$f[0]"} = $_;
  }
seek(DB,0,0);
foreach $i (sort keys %sort){
print DB $sort{$i};
}

truncate(DB, tell(DB));
close DB;
flock(DB,2);
}


sub GetProjects{
  opendir(DIR,"$rootpath/drives")||print "$!:$rootpath/drives<br>";
  @projs = readdir(DIR);
  closedir DIR;
  my(@fns);
  push(@fns,'all');                    
  $in{'allprojects'} .= qq~<tr>
  <td nowrap><b>all</b></td>
  <td nowrap><b> <input id="all" type=checkbox name=mp value="all" $sel{"all"} onClick='DoCB("all");'> View</b></td>
  <td nowrap><b> <input id="uall" type=checkbox name=mp-u value="uall" $sel{"uall"}> Upload</b></td>
  <td nowrap><b> <input id="dall" type=checkbox name=mp-d value="dall" $sel{"dall"}> Delete</b></td>
  <td nowrap><b> <input id="call" type=checkbox name=mp-c value="call" $sel{"call"}> Create Dir</b></td>
  </tr>\n~;
  foreach $j (sort @projs){
    next if ($j =~ /^\./);
    next if ($j =~ /index\.htm/);
    next if ($j =~ /\.htaccess/);
    push(@fns,$j);
    my $t = $j;
    $t=substr($t,0,30);
      $in{'allprojects'} .= qq~<tr>
      <td nowrap><b>$t</b></td>
      <td nowrap><b> <input id="$j" type=checkbox name=mp value="$j" $sel{"$j"} onClick='DoCB("$j");'> View</b></td>
      <td nowrap><b> <input id="u$j" type=checkbox name=mp-u value="$j-u" $sel{"$j-u"}> Upload </b></td>
      <td nowrap><b> <input id="d$j" type=checkbox name=mp-d value="$j-d" $sel{"$j-d"}> Delete</b></td>
      <td nowrap><b> <input id="c$j" type=checkbox name=mp-c value="$j-c" $sel{"$j-c"}> Create Dir</b></td>
      </tr>\n~;
      }

my $x = "\"".join("\",\"",@fns)."\"";
$in{'ajs'} = qq|
var g = new Array($x);
for (var x=0;x<=g.length-1;x++){
DoCB(g[x]);
}
|;

}
